/* CameraView.c generated by valac 0.40.7, the Vala compiler
 * generated from CameraView.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */


#include <glib.h>
#include <glib-object.h>
#include <clutter-gst/clutter-gst.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <canberra.h>
#include <glib/gi18n-lib.h>


#define CAMERA_WIDGETS_TYPE_CAMERA_VIEW (camera_widgets_camera_view_get_type ())
#define CAMERA_WIDGETS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraView))
#define CAMERA_WIDGETS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_IS_CAMERA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_CAMERA_VIEW))
#define CAMERA_WIDGETS_CAMERA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_CAMERA_VIEW, CameraWidgetsCameraViewClass))

typedef struct _CameraWidgetsCameraView CameraWidgetsCameraView;
typedef struct _CameraWidgetsCameraViewClass CameraWidgetsCameraViewClass;
typedef struct _CameraWidgetsCameraViewPrivate CameraWidgetsCameraViewPrivate;
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_0_PROPERTY,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_camera_view_properties[CAMERA_WIDGETS_CAMERA_VIEW_NUM_PROPERTIES];
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define CAMERA_UTILS_TYPE_ACTION_TYPE (camera_utils_action_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
enum  {
	CAMERA_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL,
	CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS
};
static guint camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_NUM_SIGNALS] = {0};

struct _CameraWidgetsCameraView {
	ClutterGstCamera parent_instance;
	CameraWidgetsCameraViewPrivate * priv;
};

struct _CameraWidgetsCameraViewClass {
	ClutterGstCameraClass parent_class;
};

typedef enum  {
	CAMERA_UTILS_ACTION_TYPE_PHOTO,
	CAMERA_UTILS_ACTION_TYPE_VIDEO
} CameraUtilsActionType;


static gpointer camera_widgets_camera_view_parent_class = NULL;

GType camera_widgets_camera_view_get_type (void) G_GNUC_CONST;
CameraWidgetsCameraView* camera_widgets_camera_view_new (void);
CameraWidgetsCameraView* camera_widgets_camera_view_construct (GType object_type);
static gint __lambda4_ (CameraWidgetsCameraView* self);
static void camera_widgets_camera_view_initialize_view (CameraWidgetsCameraView* self);
static gpointer ___lambda4__gthread_func (gpointer self);
gboolean camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self);
GType camera_utils_action_type_get_type (void) G_GNUC_CONST;
gchar* camera_utils_get_new_media_filename (CameraUtilsActionType action_type);
static void camera_widgets_camera_view_play_shutter_sound (CameraWidgetsCameraView* self);
gboolean camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self);
void camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self);
static gboolean ___lambda5_ (CameraWidgetsCameraView* self);
static gboolean ____lambda5__gsource_func (gpointer self);


static gint
__lambda4_ (CameraWidgetsCameraView* self)
{
	gint result = 0;
	g_debug ("CameraView.vala:27: Initializing camera view...");
	camera_widgets_camera_view_initialize_view (self);
	result = 0;
	return result;
}


static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) __lambda4_ ((CameraWidgetsCameraView*) self));
	g_object_unref (self);
	return result;
}


CameraWidgetsCameraView*
camera_widgets_camera_view_construct (GType object_type)
{
	CameraWidgetsCameraView * self = NULL;
	GThread* _tmp0_;
	GThread* _tmp1_;
	self = (CameraWidgetsCameraView*) g_object_new (object_type, NULL);
	_tmp0_ = g_thread_new (NULL, ___lambda4__gthread_func, g_object_ref (self));
	_tmp1_ = _tmp0_;
	_g_thread_unref0 (_tmp1_);
	return self;
}


CameraWidgetsCameraView*
camera_widgets_camera_view_new (void)
{
	return camera_widgets_camera_view_construct (CAMERA_WIDGETS_TYPE_CAMERA_VIEW);
}


gboolean
camera_widgets_camera_view_take_photo (CameraWidgetsCameraView* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self);
	}
	if (_tmp0_) {
		g_warning ("CameraView.vala:37: Device isn't ready for taking photos.");
		result = FALSE;
		return result;
	}
	_tmp1_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_PHOTO);
	_tmp2_ = _tmp1_;
	clutter_gst_camera_take_photo (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_gst_camera_get_type (), ClutterGstCamera), _tmp2_);
	_g_free0 (_tmp2_);
	camera_widgets_camera_view_play_shutter_sound (self);
	result = TRUE;
	return result;
}


gboolean
camera_widgets_camera_view_start_recording (CameraWidgetsCameraView* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self);
	}
	if (_tmp0_) {
		g_warning ("CameraView.vala:50: Device isn't ready for recording videos.");
		result = FALSE;
		return result;
	}
	_tmp1_ = camera_utils_get_new_media_filename (CAMERA_UTILS_ACTION_TYPE_VIDEO);
	_tmp2_ = _tmp1_;
	clutter_gst_camera_start_video_recording ((ClutterGstCamera*) self, _tmp2_);
	_g_free0 (_tmp2_);
	result = TRUE;
	return result;
}


void
camera_widgets_camera_view_stop_recording (CameraWidgetsCameraView* self)
{
	g_return_if_fail (self != NULL);
	if (!clutter_gst_camera_is_recording_video ((ClutterGstCamera*) self)) {
		g_warning ("CameraView.vala:62: Cannot stop recording because no record is running" \
".");
		return;
	}
	clutter_gst_camera_stop_video_recording ((ClutterGstCamera*) self);
}


static gboolean
___lambda5_ (CameraWidgetsCameraView* self)
{
	gboolean result = FALSE;
	g_signal_emit (self, camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL], 0);
	result = FALSE;
	return result;
}


static gboolean
____lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda5_ ((CameraWidgetsCameraView*) self);
	return result;
}


static void
camera_widgets_camera_view_initialize_view (CameraWidgetsCameraView* self)
{
	GstElement* flip_filter = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GValue _tmp2_ = {0};
	GstElement* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gst_element_factory_make ("videoflip", "videoflip");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	flip_filter = _tmp0_;
	_tmp1_ = flip_filter;
	g_value_init (&_tmp2_, G_TYPE_INT);
	g_value_set_int (&_tmp2_, 4);
	g_object_set_property ((GObject*) _tmp1_, "method", &_tmp2_);
	G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
	_tmp3_ = flip_filter;
	clutter_gst_camera_set_filter ((ClutterGstCamera*) self, _tmp3_);
	clutter_gst_player_set_playing ((ClutterGstPlayer*) self, TRUE);
	if (clutter_gst_camera_is_ready_for_capture ((ClutterGstCamera*) self)) {
		g_debug ("CameraView.vala:78: Camera view initalized.");
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
	} else {
		g_warning ("CameraView.vala:86: Initializing camera view failed.");
	}
	_g_object_unref0 (flip_filter);
}


static void
camera_widgets_camera_view_play_shutter_sound (CameraWidgetsCameraView* self)
{
	ca_context* context = NULL;
	ca_proplist* props = NULL;
	ca_context* _tmp0_ = NULL;
	ca_proplist* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	ca_context_create (&_tmp0_);
	_ca_context_destroy0 (context);
	context = _tmp0_;
	ca_proplist_create (&_tmp1_);
	_ca_proplist_destroy0 (props);
	props = _tmp1_;
	ca_proplist_sets (props, CA_PROP_EVENT_ID, "camera-shutter");
	ca_proplist_sets (props, CA_PROP_EVENT_DESCRIPTION, _ ("Photo taken"));
	ca_proplist_sets (props, CA_PROP_CANBERRA_CACHE_CONTROL, "permanent");
	ca_proplist_sets (props, CA_PROP_MEDIA_ROLE, "event");
	ca_context_play_full (context, (guint32) 0, props, NULL, NULL);
	_ca_proplist_destroy0 (props);
	_ca_context_destroy0 (context);
}


static void
camera_widgets_camera_view_class_init (CameraWidgetsCameraViewClass * klass)
{
	camera_widgets_camera_view_parent_class = g_type_class_peek_parent (klass);
	camera_widgets_camera_view_signals[CAMERA_WIDGETS_CAMERA_VIEW_INITIALIZED_SIGNAL] = g_signal_new ("initialized", CAMERA_WIDGETS_TYPE_CAMERA_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
camera_widgets_camera_view_instance_init (CameraWidgetsCameraView * self)
{
}


GType
camera_widgets_camera_view_get_type (void)
{
	static volatile gsize camera_widgets_camera_view_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_camera_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsCameraViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_camera_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsCameraView), 0, (GInstanceInitFunc) camera_widgets_camera_view_instance_init, NULL };
		GType camera_widgets_camera_view_type_id;
		camera_widgets_camera_view_type_id = g_type_register_static (clutter_gst_camera_get_type (), "CameraWidgetsCameraView", &g_define_type_info, 0);
		g_once_init_leave (&camera_widgets_camera_view_type_id__volatile, camera_widgets_camera_view_type_id);
	}
	return camera_widgets_camera_view_type_id__volatile;
}



