/* LoadingView.c generated by valac 0.40.7, the Vala compiler
 * generated from LoadingView.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define CAMERA_WIDGETS_TYPE_LOADING_VIEW (camera_widgets_loading_view_get_type ())
#define CAMERA_WIDGETS_LOADING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CAMERA_WIDGETS_TYPE_LOADING_VIEW, CameraWidgetsLoadingView))
#define CAMERA_WIDGETS_LOADING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CAMERA_WIDGETS_TYPE_LOADING_VIEW, CameraWidgetsLoadingViewClass))
#define CAMERA_WIDGETS_IS_LOADING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CAMERA_WIDGETS_TYPE_LOADING_VIEW))
#define CAMERA_WIDGETS_IS_LOADING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CAMERA_WIDGETS_TYPE_LOADING_VIEW))
#define CAMERA_WIDGETS_LOADING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CAMERA_WIDGETS_TYPE_LOADING_VIEW, CameraWidgetsLoadingViewClass))

typedef struct _CameraWidgetsLoadingView CameraWidgetsLoadingView;
typedef struct _CameraWidgetsLoadingViewClass CameraWidgetsLoadingViewClass;
typedef struct _CameraWidgetsLoadingViewPrivate CameraWidgetsLoadingViewPrivate;
enum  {
	CAMERA_WIDGETS_LOADING_VIEW_0_PROPERTY,
	CAMERA_WIDGETS_LOADING_VIEW_NUM_PROPERTIES
};
static GParamSpec* camera_widgets_loading_view_properties[CAMERA_WIDGETS_LOADING_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CameraWidgetsLoadingView {
	GtkBox parent_instance;
	CameraWidgetsLoadingViewPrivate * priv;
};

struct _CameraWidgetsLoadingViewClass {
	GtkBoxClass parent_class;
};

struct _CameraWidgetsLoadingViewPrivate {
	GtkGrid* inner_grid;
	GtkSpinner* spinner;
	GtkLabel* status_label;
};


static gpointer camera_widgets_loading_view_parent_class = NULL;

GType camera_widgets_loading_view_get_type (void) G_GNUC_CONST;
#define CAMERA_WIDGETS_LOADING_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CAMERA_WIDGETS_TYPE_LOADING_VIEW, CameraWidgetsLoadingViewPrivate))
CameraWidgetsLoadingView* camera_widgets_loading_view_new (void);
CameraWidgetsLoadingView* camera_widgets_loading_view_construct (GType object_type);
static void camera_widgets_loading_view_build_ui (CameraWidgetsLoadingView* self);
void camera_widgets_loading_view_set_status (CameraWidgetsLoadingView* self,
                                             const gchar* status);
static void camera_widgets_loading_view_finalize (GObject * obj);


CameraWidgetsLoadingView*
camera_widgets_loading_view_construct (GType object_type)
{
	CameraWidgetsLoadingView * self = NULL;
	self = (CameraWidgetsLoadingView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_HORIZONTAL, NULL);
	camera_widgets_loading_view_build_ui (self);
	return self;
}


CameraWidgetsLoadingView*
camera_widgets_loading_view_new (void)
{
	return camera_widgets_loading_view_construct (CAMERA_WIDGETS_TYPE_LOADING_VIEW);
}


void
camera_widgets_loading_view_set_status (CameraWidgetsLoadingView* self,
                                        const gchar* status)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (status != NULL);
	_tmp0_ = self->priv->status_label;
	gtk_label_set_label (_tmp0_, status);
}


static void
camera_widgets_loading_view_build_ui (CameraWidgetsLoadingView* self)
{
	GdkRGBA _tmp0_ = {0};
	GdkRGBA _tmp1_ = {0};
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkSpinner* _tmp5_;
	GtkSpinner* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkGrid* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkGrid* _tmp11_;
	GtkLabel* _tmp12_;
	GtkGrid* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_.red = (gdouble) 0;
	_tmp0_.green = (gdouble) 0;
	_tmp0_.blue = (gdouble) 0;
	_tmp0_.alpha = (gdouble) 1;
	gtk_widget_override_background_color ((GtkWidget*) self, GTK_STATE_FLAG_NORMAL, &_tmp0_);
	_tmp1_.red = (gdouble) 1;
	_tmp1_.green = (gdouble) 1;
	_tmp1_.blue = (gdouble) 1;
	_tmp1_.alpha = (gdouble) 1;
	gtk_widget_override_color ((GtkWidget*) self, GTK_STATE_FLAG_NORMAL, &_tmp1_);
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->inner_grid);
	self->priv->inner_grid = _tmp2_;
	_tmp3_ = self->priv->inner_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	_tmp4_ = self->priv->inner_grid;
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	_tmp5_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp5_;
	_tmp6_ = self->priv->spinner;
	g_object_set (_tmp6_, "active", TRUE, NULL);
	_tmp7_ = (GtkLabel*) gtk_label_new (_ ("Searching for video devices…"));
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp7_;
	_tmp8_ = self->priv->status_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 12);
	_tmp9_ = self->priv->inner_grid;
	_tmp10_ = self->priv->spinner;
	gtk_grid_attach (_tmp9_, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
	_tmp11_ = self->priv->inner_grid;
	_tmp12_ = self->priv->status_label;
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 0, 1, 1, 1);
	_tmp13_ = self->priv->inner_grid;
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp13_, TRUE, TRUE, (guint) 0);
}


static void
camera_widgets_loading_view_class_init (CameraWidgetsLoadingViewClass * klass)
{
	camera_widgets_loading_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CameraWidgetsLoadingViewPrivate));
	G_OBJECT_CLASS (klass)->finalize = camera_widgets_loading_view_finalize;
}


static void
camera_widgets_loading_view_instance_init (CameraWidgetsLoadingView * self)
{
	self->priv = CAMERA_WIDGETS_LOADING_VIEW_GET_PRIVATE (self);
}


static void
camera_widgets_loading_view_finalize (GObject * obj)
{
	CameraWidgetsLoadingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CAMERA_WIDGETS_TYPE_LOADING_VIEW, CameraWidgetsLoadingView);
	_g_object_unref0 (self->priv->inner_grid);
	_g_object_unref0 (self->priv->spinner);
	_g_object_unref0 (self->priv->status_label);
	G_OBJECT_CLASS (camera_widgets_loading_view_parent_class)->finalize (obj);
}


GType
camera_widgets_loading_view_get_type (void)
{
	static volatile gsize camera_widgets_loading_view_type_id__volatile = 0;
	if (g_once_init_enter (&camera_widgets_loading_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CameraWidgetsLoadingViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) camera_widgets_loading_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CameraWidgetsLoadingView), 0, (GInstanceInitFunc) camera_widgets_loading_view_instance_init, NULL };
		GType camera_widgets_loading_view_type_id;
		camera_widgets_loading_view_type_id = g_type_register_static (gtk_box_get_type (), "CameraWidgetsLoadingView", &g_define_type_info, 0);
		g_once_init_leave (&camera_widgets_loading_view_type_id__volatile, camera_widgets_loading_view_type_id);
	}
	return camera_widgets_loading_view_type_id__volatile;
}



